<?php
namespace FiloBlu\ExtAmastyGeoipRedirect\Controller\Adminhtml\Continents;

use Magento\Backend\App\Action;
use FiloBlu\ExtAmastyGeoipRedirect\Model\Continent;

class Delete extends \Magento\Backend\App\Action
{
    /**
     * {@inheritdoc}
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('FiloBlu_ExtAmastyGeoipRedirect::continents');
    }

    /**
     * Delete action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('continent_id');
        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        if ($id) {
            try {
                $model = $this->_objectManager->create(Continent::class);
                $model->load($id);
                $model->delete();
                $this->messageManager->addSuccess(__('The continent has been deleted.'));
                return $resultRedirect->setPath('*/*/');
            } catch (\Exception $e) {
                $this->messageManager->addError($e->getMessage());
                return $resultRedirect->setPath('*/*/edit', ['continent_id' => $id]);
            }
        }
        $this->messageManager->addError(__('We can\'t find a continent to delete.'));
        return $resultRedirect->setPath('*/*/');
    }
}
